#include <SoftwareSerial.h> // Libreria para utilizar cualquier par de pines digitales
                            // como pines RX i TX de un puerto serie "virtual"

#include <stdlib.h>         // Para utilizar la función strtol 

#include "Timer.h"          // Para utilizar el modulo Timer

#define RxPin 10
#define TxPin 11

SoftwareSerial mySerial(RxPin, TxPin); // Creamos un puerto serie virtual 

Timer t; 

char entrada[40] = "%01#RP0000032767**\r";
char SegonaTrama[10] = "%01**&\r";
char TramaInici[5];

bool bFinalLectura, bEsperaIniciTrama, bIniciLectura, bSegonaTrama, bPrimerCaracter, bPrimerCaracter2, bPrimerCaracter3, bPrimerCaracter4, bErrorRespuesta, bPrimer, bSegon, bTercer;
long int number, suma;

uint8_t i,j;
char four_caracters[5], four_caracters2[5] ;
char * pEnd;

void setup() {
  // put your setup code here, to run once:
  pinMode(RxPin, INPUT);
  pinMode(TxPin, OUTPUT);
  mySerial.begin(9600);
  Serial.begin(9600);

  t.every(5000,enviar);
}

void enviar() {
  for (int count = 0; entrada[count] != '\0'; count++){
    mySerial.write(entrada[count]);
  }
}

void enviar_siguiente_trama() {
  for (int count = 0; SegonaTrama[count] != '\0'; count++){
    mySerial.write(SegonaTrama[count]);
    Serial.write('\n');
    Serial.write(SegonaTrama[count]);
  }
}

void loop() {
  // put your main code here, to run repeatedly:

  t.update();
  
  if (bEsperaIniciTrama)
    delay(50);

  // Si leemos algo enviado desde el PLC y no hemos llegado al final del programa
  while (mySerial.available()>0 and not bFinalLectura){ 
    // Guardamos cada caracter recibido
    char c = mySerial.read();

    // Buscamos el inicio del programa. Cuando lo encontramos empezamos a sumar los siguientes caracteres hasta encontrar el fin de programa
    if (not bIniciLectura){
      if (four_caracters[0]=='4' and four_caracters[1]=='B' and four_caracters2[0]=='0' and four_caracters2[1]=='C')
        bIniciLectura = true;
      else if (four_caracters[2]=='4' and four_caracters[3]=='B' and four_caracters2[2]=='0' and four_caracters2[3]=='C')
        bIniciLectura = true;
      else if (four_caracters2[0]=='4' and four_caracters2[1]=='B' and four_caracters[0]=='0' and four_caracters[1]=='C')
        bIniciLectura = true;
      else if (four_caracters2[2]=='4' and four_caracters2[3]=='B' and four_caracters[2]=='0' and four_caracters[3]=='C')
        bIniciLectura = true;
        
      if (bIniciLectura){
        Serial.println("Trobat caracter inici! ");
        memset(four_caracters,0,sizeof(four_caracters)); // Borra el contenido del array "four_caracters" desde la posición 0 hasta el final sizeof
        memset(four_caracters2,0,sizeof(four_caracters2));
        j = 0;
        i = 0;
        bSegonaTrama = false;
      }
    }

    if (bIniciLectura) {
        // Miramos si hemos encontrado el final del programa
        if (four_caracters[0]=='0' and four_caracters[1]=='3' and four_caracters2[0]=='0' and four_caracters2[1]=='A')
          bFinalLectura = true;
        else if (four_caracters[2]=='0' and four_caracters[3]=='3' and four_caracters2[2]=='0' and four_caracters2[3]=='A')
          bFinalLectura = true;
        else if (four_caracters2[0]=='0' and four_caracters2[1]=='3' and four_caracters[0]=='0' and four_caracters[1]=='A')
          bFinalLectura = true;
        else if (four_caracters2[2]=='0' and four_caracters2[3]=='3' and four_caracters[2]=='0' and four_caracters[3]=='A') 
          bFinalLectura = true;
        
        if (bFinalLectura){     
          Serial.println("Trobat caracter final");
          memset(four_caracters,0,sizeof(four_caracters));
          memset(four_caracters2,0,sizeof(four_caracters2));
        }
    }
      
    // Cuando tenemos 4 caracteres miramos si hay que calcular la suma
    if (j == 4){
        j = 0;
        if (bSegonaTrama) {
          if (bIniciLectura) {
            //Serial.println("Trobat caracter inici");
            // Convertimos los carácteres recividos en Hexadecimal
            number = strtol(four_caracters,&pEnd,16);
            suma = suma + number;
            Serial.print("Numero: ");
            Serial.println(number);
            Serial.println(suma);     
          }
          memset(four_caracters,0,sizeof(four_caracters));
          bSegonaTrama = false;
        }
        else {
          if (bIniciLectura) {
            //Serial.println("Trobat caracter inici");
            // Convertimos los carácteres recividos en Hexadecimal
            number = strtol(four_caracters2,&pEnd,16);
            suma = suma + number;
            Serial.print("Numero: ");
            Serial.println(number);
          }
          memset(four_caracters2,0,sizeof(four_caracters2));
          bSegonaTrama = true;        
        }       
    }
    // Miramos si se ha llegado al final de la trama.
    if (c == '&') {
      bEsperaIniciTrama = true;
      // Comprobamos en que trama estamos y borramos los 2 últimos caracteres añadidos, que son el checksum, y no hay que contarlo para hacer la suma de comprobación
      if (bSegonaTrama) {
        // Si acabamos de hacer la suma
        if (four_caracters2[0]=='0' and four_caracters2[1]=='0' and four_caracters2[2]=='0' and four_caracters2[3]=='0'){
          four_caracters[2]='0';
          four_caracters[3]='0';
          bSegonaTrama = false;
          j=2;
        }
        // En caso contrario, hay el checksum en los dos primeros caracteres del array y lo borramos
        else {
          four_caracters2[0]='0';
          four_caracters2[1]='0';
          j=0;
        }
       }
       else {
        if (four_caracters[0]=='0' and four_caracters[1]=='0' and four_caracters[2]=='0' and four_caracters[3]=='0'){
          four_caracters2[2]='0';
          four_caracters2[3]='0';
          bSegonaTrama = true;
          j=2;
        }
        else {
          four_caracters[0]='0';
          four_caracters[1]='0';
          j=0;
        }
       }
      
       // Se debe enviar una trama para que envie las otras tramas de respuesta 
       enviar_siguiente_trama();
    }
        
    else {
      if (not bEsperaIniciTrama){
        if (bSegonaTrama) {
          Serial.write(c);
          four_caracters2[j++] = c; 
        }
        else {
          Serial.write(c);
          four_caracters[j++] = c; 
        }          
      }
      else {
        // Guardamos el inicio de la trama para comprobar que es correcto. Cuando es así se puede volver a sumar los caracteres
        TramaInici[i++] = c;
        for (int t = 0; t < sizeof(TramaInici);  ++t) {
          if (TramaInici[t]=='%'){
            bPrimer = true;
          }
          if (TramaInici[t]=='0'){
            bSegon = true;
          }
          if (TramaInici[t]=='1'){
            bTercer = true;
          }
        }
        
        if (bPrimer and bSegon and bTercer) {
          bEsperaIniciTrama = false;
          memset(TramaInici,0,sizeof(TramaInici));
          i=0;
          bPrimer = false;
          bSegon = false;
          bTercer = false;
        }
        else if (strlen(TramaInici) > 4) {
          memset(TramaInici,0,sizeof(TramaInici));
          i=0;
          bErrorRespuesta = true;
          Serial.print("Trama no valida");
          bFinalLectura = true;
        }
      }
    }
  }
  if (bFinalLectura){
      Serial.println("suma: ");
      Serial.print(suma);
    }
  bFinalLectura = false;
  bIniciLectura = false;
  suma = 0;
  memset(four_caracters,0,sizeof(four_caracters));
  j = 0;
  i = 0;
  bSegonaTrama = false;   
}
